//Add comma in string
function addComma(strin) {
	var strMoney = '' + strin;
	var rxSplit = new RegExp('([0-9])([0-9][0-9][0-9][,.])');
	var array_num = strMoney.split('.');
	array_num[0] += '.';

	do {
		array_num[0] = array_num[0].replace(rxSplit, '$1,$2');
	} while(rxSplit.test(array_num[0]));

	if (array_num.length > 1) {
		return array_num.join('');
	} else {
		return array_num[0].split('.')[0];
	}
}

function getParameter(p) {
	if(document.location.search.substring(1).length > 0) {
		var arrQueryString = document.location.search.substring(1).split('&');
		var arrParam = new Array;
		for(var i=0;i<arrQueryString.length;i++) {
			arrParam = arrQueryString[i].split('=');

			if(arrParam[0] == p) return arrParam[1];
		}

		return '';
	} else {
		return '';
	}
}

function chkValue(s) {
	if(typeof(s) == 'undefined') return '';
	else if(!s) return '';
	else return s;
}

function getLength(s) {
	var l = 0;
	if(s == null) return 0;
	for(var i=0;i<s.length;i++) {
		var c = s.charCodeAt(i);
		if (c >= 0x1000) l += 2;
		else l++;
	}

   return l;
}

function cutLength(s,l) {
	var v;
	var t = 0;

	if(s == null || s.length < 0) return s;

	for(var i=0;i<s.length;i++) {
		var c = s.charCodeAt(i);
		if (c >= 0x1000) t += 2;
		else t++;

		if(t >= l) {
			v = s.substring(0,i) + '...';
			return v;
		}
	}
}