function viewLoading(p) {

//	if(p == 1) viewMoreTop();
//	else if(p == 2) viewMoreFoot();
//	else viewMore();

	// alert to app start
	document.location.href = 'tapsonicapp://more_start?position='+p;
}

function viewMoreApp(p) {
	if(p == 1) viewMoreTop();
	else if(p == 2) viewMoreFoot();
	else viewMore();

	// alert to app end
	document.location.href = 'tapsonicapp://more_end';
}

/* Make Music List HTML */
function makeMusicList(d,p,pos,num,isNum) {
	var strFlag = '';
	var tags = [];

	// Flag String Create
	for(var i=0;i<d.flags.length;i++) {
		if(i == 0) strFlag += d.flags[i];
		else strFlag += '|' + d.flags[i];
	}

	tags.push('<div id="row'+d.piid+'">');
	tags.push('<a name="'+d.tiid+'"></a>');

	var isNew = strFlag.indexOf('new') >= 0;
	var isDown = strFlag.indexOf('down') >= 0;
	var isPremium = strFlag.indexOf('premium') >= 0;
	var isPurchased = strFlag.indexOf('purchased') >= 0;
	var isUnlocked = strFlag.indexOf('unlocked') >= 0;
	var isChallenge = strFlag.indexOf('challenge') >= 0;

	// Background Image
	if(isPremium || isPurchased) tags.push('<div class="list_premium">');
	else tags.push('<div class="list_normal">');

	if(!isUnlocked) tags.push('<ul>');
	else tags.push('<ul onClick="playMusic('+d.piid+');">');

	// Number Print
	if(isNum) {
		num++;
		if(pos == 1) tags.push('<li class="no_free">'+num+'</li>');
		else tags.push('<li class="no_hot">'+num+'</li>');
	}

	// New Icon Print
	if(isNew) tags.push('<li class="new"><img src="./images/select/new_icon.gif" alt="new" /></li>');
	else tags.push('<li class="new"></li>');

	// Disc Image Print
	tags.push('<li class="disc">');
	if(!isUnlocked) tags.push('<span class="down"><img src="./images/select/lock.png" width="31" height="37" alt="unlocked" /></span>');
	else if(isDown) tags.push('<span class="down"><img src="./images/select/select_music_icon_down.png" width="31" height="37" alt="download" /></span>');
	else tags.push('<span class="down"></span>');

	tags.push('<img src="'+d.local_image_thumb_url+'" onError="this.src=\''+d.image_thumb_url+'\'" width="40" height="40" alt="disc" />');
	tags.push('</li>');

	tags.push('<li class="info">');

	// Album Name
	tags.push('<span class="title"><span id="area">'+d.track_nm+'</span></span>');

	// Album Artist
	tags.push('<span class="writer"><span id="area">'+d.artist_nm+'</span></span>');

	tags.push('<span>');

	// Premium mark
	if(isPremium || isPurchased) tags.push('<img src="./images/select/icon_premium.png" alt="premium" />');
	// Free mark
	else if(d.coupon == 0) tags.push('<img src="./images/select/icon_free.png" width="60" height="16" alt="free" />');

	// Music Point
	if(!isPurchased && d.coupon > 0) {
		if(strFlag.indexOf('not_enough_coupon') < 0) tags.push('<span class="point">'+d.coupon+'</span>');
		else tags.push('<span class="pointoff">'+d.coupon+'</span>');
	}

	tags.push('</span>');

	tags.push('</li>');

	if(!isChallenge) {
		// All Combo Print
		tags.push('<span id="zCombo">');
		if(d.all_combo > 49) tags.push('<li class="ico_king"><img src="./images/select/'+p+'_king.png" alt="legend" /></li>');
		else if(d.all_combo > 0) tags.push('<li class="ico_'+p+'_perf">'+d.all_combo+'</li>');
		else tags.push('<li class="empty_box"></li>');
		tags.push('</span>');

		// Rank Print
		tags.push('<span id="zRank">');
		if(d.rank != '') tags.push('<li class="ico_s"><img src="./images/select/rank_'+d.rank.toLowerCase()+'.png" width="31" height="33" alt="rank_s" /></li>');
		else tags.push('<li class="empty_box"></li>');
		tags.push('</span>');

		// Challenge Print
		tags.push('<li class="chall_now"></li>');
	} else {
		tags.push('<span id="zCombo"></span>');
		tags.push('<span id="zRank"></span>');
		tags.push('<li class="chall_now"><img src="./images/select/challenge_now.png" alt="callenge_now"></li>');
	}

	// Buy Icon Print
	if(isPremium && !isPurchased) {
		tags.push('<span class="btn_buy"><img src="./images/select/nm_buy.png" width="26" height="27" onClick="buyPremium('+d.tiid+');" alt="buy" /></span>');
	}

	// Difficulty Print
	tags.push('<li class="difficulty"><span class="difficulty'+d.difficulty+'"></span></li>');

	tags.push('</ul>');
	tags.push('</div>');
	tags.push('</div>');

	return tags.join('');
}

function reloadRow(d) {
	var strFlag = '';

	// Flag String Create
	for(var i=0;i<d.flags.length;i++) {
		if(i == 0) strFlag += d.flags[i];
		else strFlag += '|' + d.flags[i];
	}

	var num = d.piid;
	var isNew = strFlag.indexOf('new') >= 0;
	var isDown = strFlag.indexOf('down') >= 0;
	var isPurchased = strFlag.indexOf('purchased') >= 0;
	var isUnlocked = strFlag.indexOf('unlocked') >= 0;
	var isChallenge = strFlag.indexOf('challenge') >= 0;

	if($('#row'+num).html()) {
		if(isUnlocked) $('#row'+num+' ul:eq(0)').attr('onClick','playMusic('+d.piid+')');

		if(isNew) $('#row'+num+' .new').html('<img src="./images/select/new_icon.gif" alt="new" />');
		else $('#row'+num+' .new').html('');

		if(!isUnlocked) $('#row'+num+' .down').html('<img src="./images/select/lock.png" width="31" height="37" alt="unlocked" />');
		else if(isDown) $('#row'+num+' .down').html('<img src="./images/select/select_music_icon_down.png" width="31" height="37" alt="download" />');
		else $('#row'+num+' .down').html('');

		if(isPurchased) {
			$('#row'+num+' .point').remove();
			$('#row'+num+' .pointoff').remove();
			$('#row'+num+' .btn_buy').remove();
		}

		if(!isChallenge) {
			if(d.all_combo > 49) $('#row'+num+' #zCombo').html('<li class="ico_king"><img src="./images/select/'+_strPatternType+'_king.png" alt="king" /></li>');
			else if(d.all_combo > 0) $('#row'+num+' #zCombo').html('<li class="ico_'+_strPatternType+'_perf">'+d.all_combo+'</li>');
			else $('#row'+num+' #zCombo').html('<li class="empty_box"></li>');

			if(d.rank == '') $('#row'+num+' #zRank').html('<li class="empty_box"></li>');
			else $('#row'+num+' #zRank').html('<li class="ico_s"><img src="./images/select/rank_'+d.rank.toLowerCase()+'.png" width="31" height="33" alt="rank_s" /></li>');

			$('#row'+num+' .chall_now').html('');
		} else {
			$('#row'+num+' #zCombo').html('');
			$('#row'+num+' #zRank').html('');
			$('#row'+num+' .chall_now').html('<img src="./images/select/challenge_now.png" alt="callenge_now">');
		}

		var newHtml = $('#wrap #row'+num).html();
		newHtml = '<div id="row'+num+'">' + newHtml + '</div>';

		putLocalStorage(num,newHtml,d.version);
	} else {
		putLocalStorage(num,'','');
	}

	var pitemds = _data.pitemds;
	for(var i=0; i != pitemds.length; ++i)
	{
	   if (pitemds[i].piid == num)
	   {
		  pitemds[i] = d;
		  break;
	   }
	}

//	_data.pitemds[d.index] = d;

	removeMemStorage();
	putMemStorage();
}

function cutLength(s,l) {
	var v;
	var t = 0;

	if(s == null || s.length < 0) return s;

	for(var i=0;i<s.length;i++) {
		var c = s.charCodeAt(i);
		if (c >= 0x1000) t += 2;
		else t++;

		if(t >= l) {
			v = s.substring(0,i) + '...';
			return v;
		}
	}
}

function getLength(s) {
	var l = 0;
	if(s == null) return 0;
	for(var i=0;i<s.length;i++) {
		var c = s.charCodeAt(i);
		if (c >= 0x1000) l += 2;
		else l++;
	}

   return l;
}

function getParameter(p) {
	if(document.location.search.substring(1).length > 0) {
		var arrQueryString = document.location.search.substring(1).split('&');
		var arrParam = new Array;
		for(var i=0;i<arrQueryString.length;i++) {
			arrParam = arrQueryString[i].split('=');

			if(arrParam[0] == p) return arrParam[1];
		}

		return '';
	} else {
		return '';
	}
}

function chkValue(s) {
	if(typeof(s) == 'undefined') return '';
	else if(!s) return '';
	else return s;
}

function playMusic(piid) {
	event.stopPropagation();
	var url = 'tapsonicapp://select?piid='+piid;
	document.location.href = url;
}

function buyPremium(tiid) {
	event.stopPropagation();
	var url = 'tapsonicapp://buy_premium?tiid='+tiid;
	document.location.href = url;
}

function moveShop() {
	var url = 'tapsonicapp://go_premium_shop';
	document.location.href = url;
}

function toggleView(n) {
	$('#wrap #group:eq('+n+')').toggle('fast');
}